#cd "Documents/corsoLP/exprcom/Semantiche/Aoggetti";;
#use "Funenv.ml";;
#use "Funstore.ml";;
#use "Syntax.ml";;
#cd "Operazionale";;
#use "Eval.ml";;
#cd "..";; (* Aoggetti *)
#cd "..";; (* Semantiche *)
#cd "Espressionipure";;
#cd "Denotazionale";;
#use "Soperations.ml";;
#cd "..";; (* Espressionipure *)
#cd "..";; (* Semantiche *)
#cd "..";; (* Exprcom *)
#cd "Datatypes";; 
#cd "4.Pilemodificabili";;
#use "MPILA.mli";;
#use "ImpMPila.ml";;
open ImpMPila;;
#cd "..";; (* Datatypes *)
#cd "..";; (* Exprcom *)
#cd "Semantiche";;
#cd "Aoggetti";;
#cd "Iterativo";;
#use "Dimensionepile.ml";;
#use "Stato.ml";;
#use "Sem.ml";;

#cd "..";; (* Aoggetti *)
#cd "..";; (* Semantiche *)
#cd "Funzionifunzionale";;
#use "Esempi.ml";;
#cd "..";; (* Semantiche *)
#cd "Procedureimperativo";;
#use "Esempi.ml";;
#cd "..";; (* Semantiche *)
#cd "Aoggetti";;
#use "Esempi.ml";;
sem(aex ,emptyenv Unbound,emptystore Undefined,emptyheap());;
(* - : eval * mval store * heap = Int 8, <fun>, <fun> *)
sem(pippo,emptyenv Unbound,emptystore Undefined,emptyheap());;
(* - : eval * mval store * heap = Int 2, <fun>, <fun> *)
sem(fact,emptyenv Unbound,emptystore Undefined,emptyheap());;
(* - : eval * mval store * heap = Int 24, <fun>, <fun> *) 
sem(pluto ,emptyenv Unbound,emptystore Undefined,emptyheap());;
(* - : eval * mval store * heap = Int 1, <fun>, <fun> *)
let (factenv, factstore, factheap) = 
semdl(fact1 ,emptyenv Unbound,emptystore Undefined,emptyheap());;
sem(factappl, factenv, factstore, emptyheap());;
(* - : eval * mval store * heap = Int 24, <fun>, <fun>  *)
let (itestore, iteheap)= semb(diccom ,emptyenv Unbound,emptystore Undefined,emptyheap());;
applystore(itestore, 0);;
(* - : mval = Mint 24 *)
let (itestore1, iteheap) = semb(mdiccom ,emptyenv Unbound,emptystore Undefined,emptyheap());;
applystore(itestore1, 0);;
(* - : mval = Mint 24 *)
let rnuovo = semclasslist([classe] ,emptyenv Unbound) ;;
(* val rnuovo: dval env = <fun>*)
let (rnuovo2,s,h) = semdv(newobj, rnuovo ,emptystore Undefined,emptyheap()) ;;
(* val rnuovo2 : dval env = <fun>
val s : mval store = <fun>
val h : heap = <fun> *)
rnuovo2 "p1";;
(* - : dval = Dobject 0 *)
(h 0) "this";;
(* - : dval = Dobject 0 *)
sem (Appl(Field(Den "p1","getx"),[]), rnuovo2, s, h);;
(* - : eval * mval store * heap = Int 1, <fun>, <fun> *)
sem (Appl(Field(Den "p1","gety"),[]), rnuovo2,s, h);;
(* - : eval * mval store * heap = Int 3, <fun>, <fun> *)
let (s4,h4) = semcl (comobj, rnuovo2 ,s, h);;
(* val s4 : mval store = <fun>
val h4 : heap = <fun>> *)
sem (Appl(Field(Den "p1","getx"),[]), rnuovo2, s4, h4);;
(* - : eval * mval store * heap = Int 38, <fun>, <fun> *)
sem (Appl(Field(Den "p1","gety"),[]), rnuovo2, s4, h4);;
(* - : eval * mval store * heap = Int 43, <fun>, <fun>  *)

let rn = semclasslist( [classe; sottoclasse] ,emptyenv Unbound) ;;
(* val rn : dval env = <fun> *)
let (rn2,s2,h2) = semdv(nobj, rn ,emptystore Undefined,emptyheap()) ;;
(* val rn2 : dval env = <fun>
val s2 : mval store = <fun>
val h2 : heap = <fun> *)
rn2 "p2";;
(* - : dval = Dobject 0 *)
(h2 0) "this";;
(* - : dval = Dobject 0 *)
sem (Appl(Field(Den "p2","getx"),[]), rn2, s2 ,h2) ;;
(* - : eval * mval store * heap = Int 1, <fun>, <fun> *)
sem (Appl(Field(Den "p2","gety"),[]), rn2, s2, h2);;
(* - : eval * mval store * heap = Int 3, <fun>, <fun> *)
sem (Appl(Field(Den "p2","getz"),[]), rn2, s2, h2);;
(* - : eval * mval store * heap = Int 105, <fun>, <fun> *)
let (s21,h21) = semcl(como ,rn2 ,s2, h2) ;;
(* val s21 : mval store = <fun>
val h21 : heap = <fun> *)
sem (Appl(Field(Den "p2","getx"),[]), rn2 ,s21, h21) ;;
(* - : eval * mval store * heap = Int 38, <fun>, <fun> *)
sem (Appl(Field(Den "p2","gety"),[]), rn2, s21 ,h21) ;;
(* - : eval * mval store * heap = Int 43, <fun>, <fun> *)
sem (Appl(Field(Den "p2","getz"),[]), rn2, s21 ,h21) ;;
(* - : eval * mval store * heap = Int 1012, <fun>, <fun> *)
let a1 = semclasslist (punti ,emptyenv Unbound);;
(* val a1 : dval env = <fun> *)
let (a2,s2,h2) = semdv(dichiarazioni, a1 ,emptystore Undefined,emptyheap());;
(* val a2 : dval env = <fun>
val s2 : mval store = <fun>
val h2 : heap = <fun>*)
let (s3,h3) = semcl(comandi ,a2 ,s2, h2);;
(* val s3 : mval store = <fun>
val h3 : heap = <fun> *)
sem (expr ,a2 ,s3, h3);;
(* - : eval * mval store * heap = Int 38, <fun>, <fun> *)

let a1 = semclasslist(punti1 ,emptyenv Unbound);;
(* val a1 : dval env = <fun> *)
let (a2,s2,h2) = semdv(dichiarazioni1, a1 ,emptystore Undefined,emptyheap());;
(* val a2 : dval env = <fun>
val s2 : mval store = <fun>
val h2 : heap = <fun> *)
let (s3,h3) = semcl(comandi1, a2, s2, h2);;
(* val s3 : mval store = <fun>
val h3 : heap = <fun> *)
let (a3, s4, h4) = semdv(newd2, a2, s3, h3);;
(* val a3 : dval env = <fun>
val s4 : mval store = <fun>
val h4 : heap = <fun>  *)
sem (expr1, a3, s4, h4);;
(* - : eval * mval store * heap = Int 39, <fun>, <fun>  *)

let a1 = semclasslist(punti2 ,emptyenv Unbound);;
(* val a1 : dval env = <fun>*)
let (a2,s2,h2) = semdv( dichiarazioni1, a1 ,emptystore Undefined,emptyheap());;
(* val a2 : dval env = <fun>
val s2 : mval store = <fun>
val h2 : heap = <fun> *)
let (s3,h3) = semcl (comandi1, a2, s2, h2);;
(* val s3 : mval store = <fun>
val h3 : heap = <fun> *)
let (a3, s4, h4) = semdv(newd2, a2, s3 ,h3);;
(* val a3 : dval env = <fun>
val s4 : mval store = <fun>
val h4 : heap = <fun> *)
sem (expr1, a3, s4, h4);;
(* - : eval * mval store * heap = Int 39, <fun>, <fun> *)       

