module Stato

type labeledconstruct =
   | Expr1 of exp
   | Expr2 of exp
   | Exprd1 of exp
   | Exprd2 of exp
   | Com1 of com
   | Com2 of com
   | Coml of labeledconstruct list

let (continuation: labeledconstruct stack) =
  emptystack(cframesize,Expr1(Eint(0)))

let (tempstack: eval stack) =
  emptystack(tframesize,Novalue)

let (tempdstack: dval stack) =
  emptystack(tdframesize,Unbound)

let globalstore: mval store ref = ref(emptystore(Undefined))

let labelcom (dl: com list) =
  let dlr = ref(dl)
  let ldlr = ref([])
  while not (!dlr = []) do
    let i = List.head !dlr
    ldlr := !ldlr @ [Com1(i)];
    dlr := List.tail !dlr
  done
  Coml(!ldlr)
