module Listenv

type 't env = (string * 't) list

exception WrongBindlist 
let emptyenv(x) = [("",x)]
let rec applyenv(x,y) = match x with
                         | [(_,e)] -> e
                         | (i1,e1) :: x1 -> if y = i1 then e1 else applyenv(x1, y)
                         | [] -> failwith("wrong env")

let bind((r: 'a env) , (l:string),  (e:'a)) = (l,e) :: r
let rec bindlist(r, il, el) = match (il,el) with
                                | ([],[]) -> r
                                | i::il1, e::el1 -> bindlist (bind(r, i, e), il1, el1)
                                | _ -> raise WrongBindlist
