#load "../../../datatypes/6.Env/Funenv.fs";;
open Funenv;;

#load "../../../datatypes/7.Store/Funstore.fs";;
open Funstore;;

#load "../Syntax.fs";;
open Syntax

#load "../../Comandipuro/Denotazionale/Eval.fs";;
open Eval

#load "../../Espressionipure/Denotazionale/Soperations.fs";;
open Soperations

#load "Sem.fs";;
open Sem

let d = [("z",Newloc(Eint 4));("w",Newloc(Eint 1))];;
let (rho2, sigma2) = semdv(d , emptyenv Unbound,emptystore Undefined);;
sem(Val(Den "z"), rho2, sigma2);;
sem(Val(Den "w"), rho2, sigma2);;
let ex = [While(Not(Eq(Val(Den "z"), Eint 0)),
                [Assign(Den "w", Let("x",Prod(Val(Den "w"),Val(Den "z")), Den "x"));
                 Assign(Den "z", Let("x",Diff(Val(Den "z"), Eint 1), Den "x"))])];;

let sigma3 = semcl(ex, rho2, sigma2);;
sem(Val(Den "z"), rho2, sigma3);;
sem(Val(Den "w"), rho2, sigma3);;
let sigma4 = semcl ([Block(d, ex)] ,emptyenv Unbound, emptystore Undefined);;

