#load "../../../datatypes/6.Env/Funenv.fs";;
open Funenv;;

#load "../../../datatypes/7.Store/Funstore.fs";;
open Funstore;;

#load "../Syntax.fs";;
open Syntax

#load "../../Comandipuro/Denotazionale/Eval.fs";;
open Eval

#load "../../Espressionipure/Denotazionale/Soperations.fs";;
open Soperations

#load "Sem.fs";;
open Sem

let (l1,sigma1) = allocate(emptystore(Undefined), Mint 4);;
let rho1 = bind (emptyenv(Unbound), "z", Dloc l1);;
let (l2,sigma2) = allocate(sigma1, Mint 1);;
let rho2 = bind (rho1, "w", Dloc l2);;
sem (Val(Den "z")) rho2 sigma2;;
sem (Val(Den "w")) rho2 sigma2;;
let ex = [While(Not(Eq(Val(Den "z"), Eint 0)),
                [Assign(Den "w", Prod(Val(Den "w"),Val(Den "z")));
                 Assign(Den "z", Diff(Val(Den "z"), Eint 1))])];;
let sigma3 = semcl ex rho2 sigma2;;
sem (Val(Den "z")) rho2 sigma3;;
sem (Val(Den "w")) rho2 sigma3;;
