#load "../Funzionifunzionale/Syntax.fs";;
open Syntax

#load "StaticSyntax.fs";;
open StaticSyntax

#load "../Funzionifunzionale/Iterativo/Dimensionepile.fs";;
open Dimensionepile

#load "../../datatypes/4.Pilemodificabili/ImpMPila.fs";;
open ImpMPila;;

#load "DominiStatic.fs";;
open DominiStatic

#load "../Espressionipure/Denotazionale/Soperations.fs";;
open Soperations

#load "StaticSem.fs";;

#load "StaticExpSem.fs";;

#load "../Funzionifunzionale/Esempi.fs";;
open Esempi

StaticExpSem.sem(StaticSem.sem(aex, emptyenv Unbound), emptyenv Unbound);;
(* - : eval = Int 8 *)
StaticExpSem.sem(StaticSem.sem(pippo, emptyenv Unbound), emptyenv Unbound);;
(* - : eval = Int 2 *)
StaticExpSem.sem(StaticSem.sem(fact, emptyenv Unbound), emptyenv Unbound);;
(* - : eval = Int 24 *)
StaticExpSem.sem(StaticSem.sem(pluto, emptyenv Unbound), emptyenv Unbound);;
(* - : eval = Int 1 *)

let expo = Let("expo",
               Rec("expo",
                   Fun (["base";"esp"],
                        Let("f", Fun(["x"],
                                     Ifthenelse(Iszero (Den "esp"),
                                                Appl(Den "f", [Eint 1]),
                                                Prod(Den "x",
                                                     Appl(Den "expo",
                                                          [Den "x";Diff(Den "esp", Eint 1)])))),
                            Appl (Den "f", [Den "base"])))),
               Appl (Den "expo", [Den "x"; Eint 3]));;

StaticSem.sem(expo, emptyenv Unbound);;

let rettest = Appl(Appl(Fun(["x"],
                            Fun(["y"],Sum(Den("x"),Den("y")))),
                        [Eint 3]),
                   [Eint 5]);;
let retstatic = StaticSem.sem(rettest, emptyenv Unbound);;
StaticExpSem.sem(retstatic, emptyenv Unbound);;
