module ImpMPila: MPILA =
  struct
   type 'x stack = ('x array) * int ref
   exception Emptystack
   exception Fullstack  
   exception Wrongaccess 
   let emptystack(nm,(x: 'a)) = ((Array.create nm x, ref(-1)): 'a stack)
   let push(x,((s,n): 'x stack)) = if !n = (Array.length(s) - 1) then
                   raise Fullstack else 
                   (Array.set s (!n +1) x;
                   n := !n +1)
   let top(((s,n): 'x stack)) = if !n = -1 then
                           raise Emptystack
                           else Array.get s !n 
   let pop(((s,n): 'x stack)) = if !n = -1 then
                           raise Emptystack
                           else n:= !n -1
   let empty(((s,n): 'x stack)) = if !n = -1 then
                           true
                           else false 
   let lungh( (s,n): 'x stack) = !n 
   let svuota (((s,n): 'x stack)) = n := -1
   let setta (((s,n): 'x stack), k, (v: 'x)) =
   (*          if not(k > !n) then   *)
	     Array.set s k v
   (*          else raise Wrongaccess  *)
   let access (((s,n): 'x stack), k) =
(*          if not(k > !n) then   *)
          Array.get s k
(*          else raise Wrongaccess  *)
 end